Package: TFHAZ
Type: Package
Title: Transcription Factor High Accumulation Zones
Version: 1.35.0
Author: Alberto Marchesi, Silvia Cascianelli, Marco Masseroli
Maintainer: Gaia Ceddia <gaia.ceddia@polimi.it>
Description: It finds trascription factor (TF) high accumulation DNA zones, 
    i.e., regions along the genome where there is a high presence of different 
    transcription factors. Starting from a dataset containing the genomic
    positions of TF binding regions, for each base of the selected chromosome
    the accumulation of TFs is computed. Three different types of accumulation 
    (TF, region and base accumulation) are available, together with the
    possibility of considering, in the single base accumulation computing, 
    the TFs present not only in that single base, but also in its neighborhood,
    within a window of a given width. Two different methods for the search of TF
    high accumulation DNA zones, called "binding regions" and "overlaps", are 
    available. In addition, some functions are provided in order to analyze, 
    visualize and compare results obtained with different input parameters.
License: Artistic-2.0
Encoding: UTF-8
Imports: GenomicRanges, S4Vectors, grDevices, graphics, stats, utils,
        IRanges, methods, ORFik
biocViews: Software, BiologicalQuestion, Transcription, ChIPSeq,
        Coverage
LazyData: true
Depends: R (>= 3.5.0)
Suggests: BiocStyle, knitr, rmarkdown
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/TFHAZ
git_branch: devel
git_last_commit: 05269b1
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 01:34:18 UTC; biocbuild

## The function plots the accumulation vector obtained with the accumulation
## function. The function works only if the "accumulation" in input is
##calculated for a single chromosome.
## Input:
##    accumulation: a list of four elements, as the output of the accumulation
##    function.
##    chr: optional argument, needed if the accumulation input is found with chr
##    = "all"; a string or a vector containing strings with the name of the
##    chromosome(s) (e.g., "chr1" or c("chr1", "chr4"))
## Output: a .png file (or more) with the plot(s).

plot_accumulation <- function(accumulation, chr = NULL) {
    if (!is.list(accumulation))
        stop("'accumulation' must be an object of type 'list'.")

    if (class(accumulation$accvector) != "Rle" & class(accumulation$accvector)
        != "SimpleRleList")
        stop("'accvector' element of the list 'accumulation' must be of class
                'Rle' or 'SimpleRleList'.")

    if (accumulation$chr != "all") {

    png(filename = paste(accumulation$acctype, "_w_", accumulation$w, "_",
                        accumulation$chr, ".png", sep = ""))
    plot(accumulation$accvector, type = "l", xlab = "base", ylab =
            paste("# of ", accumulation$acctype, "s", sep = ""))
    dev.off()
    } else {

    if (accumulation$chr == "all" & chr == NULL)
        stop("argument 'chr' is missing")

    for (i in seq_along(chr)) {

        acc <- eval(parse(text = paste("a$accvector$", chr[i], sep = "")))
        png(filename = paste(accumulation$acctype, "_w_", accumulation$w, "_",
        chr[i], ".png", sep = ""))
        plot(acc, type = "l", xlab = "base", ylab =
        paste("# of ", accumulation$acctype,
        "s", sep = ""))
    dev.off()
        }
    }
}

##Finds transcription factor dense DNA zones for different accumulation
##threshold values. The function works only if the "accumulation" in input is
##calculated for a single chromosome.
##input:
##    accumulation: a list of four elements, as the output of the accumulation
##    function.
##    threshold_step: an integer, the step used to calculate the threshold
##    values.
##    chr: optional argument, a string with a cromosome name. It is needed to
##    apply the function only to a single cromosome present in the accumulation
##    input found with chr = "all". If chr = "all" (default value) the function
##    operates for all the chromosome present in the input.
##    writeBed: When set to TRUE, for each threshold value (and for each
##    chromosome) a ".bed" file with the chromosome and genomic coordinates of
##    the dense zones found is created.
##output: a list of eight elements:
##    zones: a list with "GRanges" objects with the dense zones found for each
##    chromosome and threshold value considered.
##    zones_count: a list with a data frame, for each chromosome considered,
##    containing the considered threshold values and the number of dense zones
##    obtained with each of the threshold values.
##    bases_count: a list with a data frame, for each chromosome considered,
##    containing the considered threshold values and the total number of bases
##    belonging to the dense zones obtained with each of the threshold values.
##    lengths: a list with a data frame, for each chromosome considered,
##    containing the considered threshold values and min, max, mean, median and
##    standard deviation of the dense zone lengths obtained with each of the
##    considered threshold values.
##    distances: a list with a data frame, for each chromosome considered,
##    containing the considered threshold values and min, max, mean, median and
##    standard deviation of the distances between adjacent dense zones obtained
##    with each of the threshold values.
##    acctype: a string with the accumulation type used.
##    chr: a string with the chromosome name associated with the accumulation
##    vector used.
##    w: an integer with half-width of the window used to calculate the
##    accumulation vector.
##    When writeBed is set to TRUE, for each threshold value (and for each
##    chromosome) a ".bed" file with the chromosome and genomic coordinates of
##    the dense zones found is created.



dense_zones <- function(accumulation, threshold_step, chr = NULL, writeBed =
                            FALSE) {

    if (!is.list(accumulation))
        stop("'accumulation' must be an object of type 'list'.")

    if (class(accumulation$accvector) != "Rle" & class(accumulation$accvector)
        != "SimpleRleList")
        stop("'accvector' element of the list 'accumulation' must be of class
            'Rle' or 'SimpleRleList'.")
    if (!is.numeric(threshold_step))
        stop("'threshold_step' must be an object of type 'numeric'.")
    if (threshold_step < 1)
        stop("'threshold_step' must be > 0.")
    ## initializing vectors
    d_zones <- list()
    zones_count <- list()
    bases_count <- list()
    lengths <- list()
    distances <- list()

    acc_tf <- accumulation$accvector
    if(accumulation$chr != "all") {
        acc_regions <- GRanges(seqnames = rep(accumulation$chr,
                        length(ranges(acc_tf))), ranges = ranges(acc_tf),
                        score = runValue(acc_tf))
        c <- accumulation$chr
    } else {

        acc_regions <- as(acc_tf,"GRanges")

        if(!is.null(chr)) {
            c <- chr
            acc_regions <- acc_regions[seqnames(acc_regions) == chr]
        } else {
            c <- "all"
        }
    }
    acc_regions <- acc_regions[score(acc_regions) > 0]

    u=unique(seqnames(acc_regions))

    for (k in seq_along(u)) {

        acc_regions_chr <- acc_regions[seqnames(acc_regions) == u[k]]
        threshold <- seq(1, max(score(acc_regions_chr)), threshold_step)
        n_zones <- vector()
        n_bases <- vector()
        length_zone_min <- vector()
        length_zone_max <- vector()
        length_zone_mean <- vector()
        length_zone_median <- vector()
        length_zone_sd <- vector()
        dist_zone_min <- vector()
        dist_zone_max <- vector()
        dist_zone_mean <- vector()
        dist_zone_median <- vector()
        dist_zone_sd <- vector()
        z=list()
        for (i in seq_along(threshold)) {

            zones <- reduce(acc_regions_chr[score(acc_regions_chr) >=
                                                threshold[i]])

            z[[i]]=zones
        ## counting the number of dense zones that are formed by contiguos bases
        ## given a threshold, and the number of bases belonging to the zones.

            n_bases[i] <- sum(width(zones))
            n_zones[i] <- length(zones)

            if (writeBed == TRUE) {
            ## writing on files chromosome and positions of starting and ending
            ## points
                write.table(data.frame(rep(u[k], length(zones)),
                            start(zones) - 1, end(zones)),
                            file = paste(accumulation$acctype, "_acc_w_",
                            accumulation$w, "_", u[k], "_dense_zones_th_",
                            threshold[i], ".bed", sep = ""), row.names = FALSE,
                            col.names = FALSE, quote = FALSE, sep = "\t")

                ## finding elements of length dataframe
            }
            length_zone_min[i] <- min(width(zones))
            length_zone_max[i] <- max(width(zones))
            length_zone_mean[i] <- mean(width(zones))
            length_zone_median[i] <- median(width(zones))
            length_zone_sd[i] <- sd(width(zones))

            ## calculating distances of dense zones
            if (length(zones) > 1) {

                dist_zone <- start(zones)[-1] - end(zones[-length(end(zones))])
                dist_zone_min[i] <- min(dist_zone)
                dist_zone_max[i] <- max(dist_zone)
                dist_zone_mean[i] <- mean(dist_zone)
                dist_zone_median[i] <- median(dist_zone)
                dist_zone_sd[i] <- sd(dist_zone)
            } else {
                dist_zone <- NA
                dist_zone_min[i] <- NA
                dist_zone_max[i] <- NA
                dist_zone_mean[i] <- NA
                dist_zone_median[i] <- NA
                dist_zone_sd[i] <- NA


            }


        }
        zones_count[[k]] <- data.frame(threshold, n_zones)
        bases_count[[k]] <- data.frame(threshold, n_bases)

        lengths[[k]] <- data.frame(threshold, n_zones, length_zone_min,
                                length_zone_max, length_zone_mean,
                                length_zone_median, length_zone_sd)

        distances[[k]] <- data.frame(threshold, n_zones, dist_zone_min,
                                dist_zone_max, dist_zone_mean,
                                dist_zone_median, dist_zone_sd)
        names(z) <- paste("th_", threshold, sep="")
        d_zones[[k]] <- z
    }

    ## result dataframes creation

    names(zones_count) <- u
    names(bases_count) <- u
    names(lengths) <- u
    names(distances) <- u
    names(d_zones) <- u
    return(list(zones = d_zones, zones_count = zones_count, bases_count =
                    bases_count, lengths = lengths, distances = distances,
                chr = c, w = accumulation$w, acctype =
                    accumulation$acctype))

}

## This function finds transcription factor high accumulation DNA zones (TFHAZ).
## Two different methods for the search of TF high accumulation DNA zones
## are available, with two possible methods to find the threshold value.
##
## input:
##    accumulation: list of four elements containing: a sparse vector with
##    accumulation values (e.g.,obtained with the accumulation function),
##    the accumulation type, a chromosome name, and the half-width of the
##    window used for the accumulation count.
##    method:  a string with the name of the method used to find high
##    accumulation zones: "binding_regions" or "overlaps".
##    data a GRanges object containing coordinates of TF binding regions and
##    their TF name. It is needed in the case of "binding regions" method
##    threshold: a string with the name of the method used to find the threshold
##    value: "std" or "top_perc".
##    k: an integer with the percentage (with the top_perc method) or the
##    number of std deviations (with the std method) to be used in order to 
##    find the threshold.
## output: A list of nine elements:
##    zones: a GRanges object containing the coordinates of the high
##    accumulation zones.
##    n_zones: an integer containing the number of high accumulation zones
##    obtained.
##    n_bases: an integer containing the total number of bases belonging to
##    the accumulation zones obtained.
##    lengths: a vector containing the considered threshold value and min,
##    max, mean, median and standard deviation of the accumulation
##    zone lengths obtained.
##    distances: a vector containing the considered threshold value and  min,
##    max, mean, median and standard deviation of the distances between adjacent
##    accumulation zones obtained.
##    TH: a number with the threshold value found.
##    acctype: a string with the accumulation type used.
##    chr: a string with the chromosome name associated with the
##    accumulation vector used.
##    w: an integer with half-width of the window used to calculate the
##    accumulation vector.
## Furthermore, a ".bed" file with the chromosome, genomic coordinates and 
## accumulation values of the found accumulation zones and a ".png" file with 
## the plot of the TFHAZ found along the chromosome (only if the "accumulation" 
## in input is calculated for a single chromosome) can be created.



high_accumulation_zones <- function(accumulation, method = c("overlaps",
                                    "binding_regions"), data, threshold =
                                    c("std", "top_perc"), k = 2, writeBed =
                                        FALSE, plotZones = FALSE)
        {

    if (!is.list(accumulation))
        stop("'accumulation' must be an object of type 'list'.")
    if (class(accumulation$accvector) != "Rle" & class(accumulation$accvector)
        != "SimpleRleList")
        stop("'accvector' element of the list 'accumulation' must be of class
            'Rle'.")
    if (!is.character(method))
        stop("'method' must be an object of type 'character'.")
    if (!is.character(threshold))
        stop("'threshold' must be an object of type 'character'.")
    ## input accumulation vector
    acc_tf <- accumulation$accvector
    if(accumulation$chr != "all") {
        acc_regions <- GRanges(seqnames = rep(accumulation$chr,
            length(ranges(acc_tf))), ranges = ranges(acc_tf), score =
            runValue(acc_tf))
    } else {
    acc_regions <- as(acc_tf,"GRanges") }


    if (method == "binding_regions") {
        if (missing(data))
            stop("argument data is missing")
        if (accumulation$w != 0)
            stop("in binding regions method w must be equal to 0")
        acc_reg <- reduce(acc_regions[score(acc_regions) > 0])
        tf <- unique(elementMetadata(data))[,1]
        count_list <- list()
        for(i in seq_along(tf)) {
            data_tf <- data[elementMetadata(data)[,1] == tf[i]]
            count_list[[i]] <- countOverlaps(acc_reg, data_tf)
            count_list[[i]][count_list[[i]] > 1] <- 1
        }
        count_list <- Reduce("+", count_list)
        acc_regions <- GRanges(acc_reg, score = count_list)
    }

    if (method == "overlaps") {
        acc_regions <- acc_regions[score(acc_regions) > 0]
    }

    ## finding the threshold
    if (threshold == "top_perc") {
        if(missing(k))
            stop("argument k is missing")
        if (!is.numeric(k))
            stop("'k' must be an object of type 'numeric'.")
        if (k < 0 || k >= 100)
            stop("'k' must be >= 0 and <= 100.")
        n_regions <- length(acc_regions)
        ul <- unique(score(acc_regions))
        max_index <- max(ul)
        ul <- sort(ul,decreasing = FALSE)
        up_perc <- n_regions * (1 - (k * 0.01))
        sum_ACC_count=vector()
        ACC_count=vector()
        for(i in seq_along(ul)){
            data_ACC <- acc_regions[score(acc_regions) == ul[i]]
            ACC_count[i] <- length(data_ACC)
            if (i == 1) {
                sum_ACC_count[i] <- ACC_count[i]
            } else {
                sum_ACC_count[i]=sum_ACC_count[i-1]+ACC_count[i]
            }
        }
        TH <- ul[which(sum_ACC_count > up_perc)[1]]
        
    }

    if (threshold == "std") {
      if(missing(k))
        k <- 2
      acc <- score(acc_regions) * width(acc_regions)
      mean_acc <- sum(acc) / sum(width(acc_regions))
      std_reg = width(acc_regions) * (score(acc_regions) - mean_acc)^2
      std_acc <- sqrt(sum(std_reg) / (sum(width(acc_regions)) - 1))
      TH <- ceiling(mean_acc + k * std_acc)
      ul <- unique(score(acc_regions))
      max_index <- max(ul)
    }

    ## finding high accumulation zones
    zones_old <- reduce(acc_regions[score(acc_regions) >= TH])
    acc_regions <- acc_regions
    zones <- reduceKeepAttr(acc_regions[score(acc_regions) >= TH], 
                             keep.names = TRUE, with.revmap = TRUE)
    indexes <- as.numeric(zones@elementMetadata@listData[["revmap"]]@partitioning@end)
    acc_val <- score(acc_regions)[indexes]    
    ## finding the number of bases belonging to the zones
    n_bases <- sum(width(zones))
    ## finding the number of zones
    n_zones <- length(zones)




    if (accumulation$chr != "all" & plotZones == TRUE) {
        ## finding the bases belonging to the zones
        bases <- Rle()
        for (i in seq_along(zones)) {
            bases <- append(bases, start(zones)[i]:end(zones)[i])
        }

        ## plot
        png(filename = paste("high_accumulation_zones_TH_", round(TH, digits =
                            1), "_", accumulation$acctype, "_acc_w_",
                            accumulation$w, "_", accumulation$chr, ".png",
                            sep = ""))
        plot(accumulation$accvector, type = "l", xlab = "base", ylab = paste
            ("# of ", accumulation$acctype, "s", sep = ""))
        points(bases, rep(0, length(bases)), col = "red", pch = 15)
        abline(h = TH, col = "red")
        legend("topleft", legend = c("threshold", "HOT\nzones"),
                col = "red", pch = c(NA, 15), lty = c(1, NA), bty='n')
        dev.off()
    }

    if (writeBed == TRUE) {
    ## writing on files chromosome and positions of starting and ending points
    write.table(data.frame(seqnames(zones), start(zones) - 1, end(zones), acc_val),
                file = paste(accumulation$acctype, "_acc_w_", accumulation$w,
                "_", accumulation$chr, "_dense_zones_th_", round(TH, digits = 1)
                , ".bed", sep = ""), row.names = FALSE, col.names = FALSE,
                quote = FALSE, sep = "\t") }

    ## finding elements of length dataframe
    length_zone_min <- min(width(zones))
    length_zone_max <- max(width(zones))
    length_zone_mean <- mean(width(zones))
    length_zone_median <- median(width(zones))
    length_zone_sd <- sd(width(zones))

    ## calculating distances of dense zones
    if (length(zones) > 1) {

        dist_zone <- start(zones)[-1] - end(zones[-length(end(zones))])
        dist_zone_min <- min(dist_zone)
        dist_zone_max <- max(dist_zone)
        dist_zone_mean <- mean(dist_zone)
        dist_zone_median <- median(dist_zone)
        dist_zone_sd <- sd(dist_zone)
    } else {
        dist_zone <- NA
        dist_zone_min <- NA
        dist_zone_max <- NA
        dist_zone_mean <- NA
        dist_zone_median <- NA
        dist_zone_sd <- NA
    }

    ## vectors creation
    lengths <- c(TH, n_zones, length_zone_min, length_zone_max,
                length_zone_mean, length_zone_median, length_zone_sd)
    names(lengths) = c("TH", "n_zones", "length_zone_min", "length_zone_max",
                "length_zone_mean", "length_zone_median", "length_zone_sd")
    distances <- c(TH, n_zones, dist_zone_min, dist_zone_max, dist_zone_mean,
                    dist_zone_median, dist_zone_sd)
    names(distances) <- c("TH", "n_zones", "dist_zone_min", "dist_zone_max",
                        "dist_zone_mean", "dist_zone_median", "dist_zone_sd")

    return(list(zones = zones, n_zones = n_zones, n_bases = n_bases, lengths =
                lengths, distances = distances, TH = TH, chr = accumulation$chr,
                w = accumulation$w, max_accumulation_index = max_index, acctype = accumulation$acctype))

}

## Creates a vector with accumulation counts of transcription factors for each
## chromosome base.
## input:
## data: a GRanges object containing coordinates of TF binding regions
## and their TF name.
## acctype: a string with the name of the accumulation type: "TF",
## "region", "base".
## chr: a string with the name of the chromosome (e.g., "chr1"). With chr="all"
## all the chromosomes in the input GRanges object are considered.
## w: an integer, half-width of the window that defines the neighborhood
## of each base.
## output: A list of four elements.
## accvector: a Rle (or SimpleRleList if chr = "all") object containing the
## accumulation for each base of the selected chromosome.
## acctype: a string with the accumulation type used.
## chr: a string with the chromosome name associated with the accumulation
## vector.
## w: an integer with the half-width of the window used to calculate the
## accumulation vector.

accumulation <- function(data, acctype = c("TF", "region", "base"), chr, w) {
    if (class(data) != "GRanges")
        stop("'data' must be an object of class 'GRanges'.")
    if (!is.character(acctype))
        stop("'acctype' must be an object of type 'character'.")
    if (!is.character(chr))
        stop("'chr' must be an object of type 'character'.")
    if (!is.numeric(w))
        stop("'w' must be an object of type 'numeric'.")
    if (w < 0)
        stop("'w' must be >= 0.")
    # dataset with only the selected chromosome
    if (chr == "all") {
        chrom <- data
        }
    else {
        chrom <- data[seqnames(data) == chr]
        }
    acctype <- match.arg(acctype)

    if (acctype == "TF") {
        # TF accumulation

        # find the number of different TF present in the chromosome
        tf <- unique(elementMetadata(data))[, 1]
        acc_tf <- list()
        for (k in seq_along(tf)) {

            # dataset for a single TF and the selected chromosome
            chrom_tf <- chrom[elementMetadata(chrom)[, 1] == tf[k]]
            # ranges expansion
            start(chrom_tf) <- pmax(1, start(chrom_tf) - w)
            end(chrom_tf) <- end(chrom_tf) + w
            # calculating the coverage
            v_tf <- coverage(chrom_tf, width = max(end(chrom)) + w)
            # max accumulation possible value = 1
            v_tf[v_tf >= 1] <- 1

            acc_tf[[k]] <- v_tf

        }
        # sum of all different TFs
        acc <- Reduce(`+`, acc_tf)
        if (chr != "all") {
        acc <- eval(parse(text = paste("acc$", chr, sep = ""))) }
        return(list(accvector = acc, chr = chr, w = w, acctype = acctype))
    }

    if (acctype == "region") {
        # region accumulation
        # ranges expansion
        start(chrom) <- pmax(1, start(chrom) - w)
        end(chrom) <- end(chrom) + w
        # calculating the coverage
        acc <- coverage(chrom, width = max(end(chrom)))
        if (chr != "all") {
        acc <- eval(parse(text = paste("acc$", chr, sep = ""))) }
        return(list(accvector = acc, chr = chr, w = w, acctype = acctype))
    }

    if (acctype == "base") {
        # base accumulation
        # calculating the coverage
        v_b <- coverage(chrom, width = max(end(chrom)))

        #v_b <- eval(parse(text = paste("v_b$", chr, sep = "")))
        # calculating the sum of the bases belonging to the neighborhood
        v_b_1 <- lapply(v_b, append, values = rep(0, w))
        v_b_2 <- lapply(lapply(v_b,rev),append, values=rep(0, w))
        rs1 <- lapply(v_b_1, runsum, k = w + 1)
        rs2 <- lapply(lapply(v_b_2, runsum, k = w + 1), rev)
        acc_1 <- Map("+", rs1, rs2)
        acc <- Map("-", acc_1, v_b)
        acc <- as(acc,"SimpleRleList")
        if (chr != "all") {
            acc <- eval(parse(text = paste("acc$", chr, sep = ""))) }
        return(list(accvector = acc, chr = chr, w = w, acctype = acctype))
    }

}

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)

## ----include=FALSE------------------------------------------------------------
library(TFHAZ)
library(GenomicRanges)
library(IRanges)
library(S4Vectors)
data("data_man")

## -----------------------------------------------------------------------------
# load and visualize the dataset:
data("Ishikawa")
dim(as.data.frame(Ishikawa))
head(Ishikawa)


## -----------------------------------------------------------------------------
# calculate TF accumulation for the chromosome 21 for w=0
TF_acc_21_w_0 <- accumulation(Ishikawa, "TF", "chr21", 0)

## ----eval=FALSE---------------------------------------------------------------
# # plot the accumulation vector
# plot_accumulation(TF_acc_21_w_0)

## ----echo=FALSE, fig.align='center', out.width='75%', fig.cap = "*Plot of the TF accumulation vector for the chromosome 21, obtained for w=0.*"----
knitr::include_graphics('./TF_w_0_chr21.png')

## -----------------------------------------------------------------------------
# find dense DNA zones, with threshold step equal to 1
TF_dense_21_w_0 <- dense_zones(TF_acc_w_0, 1, chr = "chr21")
TF_dense_21_w_0

## ----echo=FALSE, fig.align='center', fig.small = TRUE, fig.cap = "*Content of the 'bed' file with the coordinates of the seven dense DNA zones found  for the chromosome 21 with transcription factor accumulation threshold value equal to 12.*"----
knitr::include_graphics('./dense_zones_12.PNG')

## ----fig.align='center', fig.cap = "*Plot of the number of dense DNA zones found varying the TF accumulation threshold value for the chromosome 21; the point with maximum slope change is plotted circulated with a red full line.*"----
plot_n_zones(TF_dense_w_0, chr = "chr21")

## ----fig.align='center', fig.cap="*Plot of the number of dense DNA zones (red full line) and of the total number of bases belonging to dense DNA zones (blue dashed line) obtained with different values of neighborhood window half-width w for the chromosome 21.*"----
# l is a list with four objects obtained with the dense_zones function with 
# w = 10, 100, 1000, 10000.
l <- list(TF_dense_w_10, TF_dense_w_100, TF_dense_w_1000, TF_dense_w_10000)
# plot
w_analysis(l, chr = "chr21")

## ----PCA, fig.keep="none"-----------------------------------------------------
# TF_dense_21_w_10 is the output of dense_zones function applied to the
# accumulation vector found with w=10, chr="chr21", acctype="TF".
# reg_dense_21_w_10 is the output of dense_zones function applied to the
# accumulation vector found with w=10, chr="chr21", acctype="reg".   
# base_dense_21_w_10 is the output of dense_zones function (with 
# threshold_step=21 in order to have 14 threshold values as in the other two
# inputs) applied to the accumulation vector found with w=10, chr="chr21",
# acctype="base".
# PCA
n_zones_PCA(TF_dense_w_10, reg_dense_w_10, base_dense_w_10, chr = "chr21")

## ----echo=FALSE, fig.align='center', out.width = '75%',fig.cap = "*Plot of the variances of the principal components.*"----
knitr::include_graphics('./PCA_1.png')

## ----echo=FALSE, fig.align='center', out.width='75%', fig.cap = "*Plot of the cumulate variances of the principal components.*"----
knitr::include_graphics('./PCA_2.png')

## ----echo=FALSE, fig.align='center', out.width='100%', fig.cap = "*Plot of the loadings of the three principle components.*"----
knitr::include_graphics('./PCA_3.png')

## -----------------------------------------------------------------------------
# find high accumulation DNA zones
TF_acc_21_w_0 <- accumulation(Ishikawa, "TF", "chr21", 0)
TFHAZ_21_w_0 <- high_accumulation_zones(TF_acc_21_w_0, method = "overlaps",
threshold = "std")
TFHAZ_21_w_0

## ----echo=FALSE, fig.align="center", out.width='75%',fig.cap = "*Plot of the TF accumulation vector (for the chromosome 21, obtained for w=0) and of the high accumulation DNA zones (red boxes on the x axis) found; the threshold used to find these zones (7,268413) is shown with a red horizontal line.*"----
knitr::include_graphics('./high_accumulation_zones_TH_7.3_TF_acc_w_0_chr21.png')

## ----echo=FALSE, fig.align='center', fig.small = TRUE, fig.cap = "*Content of the 'bed' file with the coordinates of 31 out of the 93 high accumulation DNA zones found.*"----
knitr::include_graphics('./HAZ_bed.PNG')

## The function performs the Principal Component Analysis (PCA) of the number of
## dense zones obtained by varying the threshold on accumulation values obtained
## with the three methods of accumulation (TF, region, base).
## Input:
##    lists with the results of the dense_zones function using the TF,
##    region and base accumulation method (in this order) and varying the
##    thresholds on the considered accumulation values.
##    chr: optional argument, needed if the input is found with chr = "all";
##    a string or a vector containing strings with the name of the chromosome
##    (e.g., "chr1")
## Output: A list with a summary containing the standard deviation on each
## principal component, the proportion of variance explained by each principal
## component, the cumulative proportion of variance described by each principal
## component, and the loadings of each principal component. In addition, a plot
## with the variances of the principal components; a plot with the cumulate
## variances of the principal components; three plots with the loadings of the
## three principal components; a plot with the vector obtained, for each
## threshold value, as linear combination of the number of dense zones
## (after scaling) for each accumulation type, using as linear combination
## coefficients the loadings of the first principal component for the three
## accumulation types.

n_zones_PCA <- function(TF_zones, region_zones, base_zones, chr = NULL) {
    if (!is.list(TF_zones))
        stop("'TF_zones' must be an object of type 'list'.")
    if (!is.list(region_zones))
        stop("'region_zones' must be an object of type 'list'.")
    if (!is.list(base_zones))
        stop("'base_zones' must be an object of type 'list'.")
    if (TF_zones$acctype != "TF")
        stop("TF_zones must contain dense zones from TF accumulation type.")
    if (region_zones$acctype != "region")
    stop("region_zones must contain dense zones from region accumulation type.")
    if (base_zones$acctype != "base")
    stop("base_zones must contain dense zones from base accumulation type.")

    if (TF_zones$chr != "all" & TF_zones$chr == region_zones$chr &
        TF_zones$chr == base_zones$chr) {
        chr <- TF_zones$chr
    }

    if (length(eval(parse(text = paste("TF_zones$zones_count$", chr,
                                    "$n_zones", sep = "")))) !=
        length(eval(parse(text = paste("region_zones$zones_count$", chr,
                                    "$n_zones", sep = "")))) ||
        length(eval(parse(text = paste("TF_zones$zones_count$", chr,
                                    "$n_zones", sep = "")))) !=
        length(eval(parse(text = paste("base_zones$zones_count$", chr,
                                    "$n_zones", sep = "")))) ||
        length(eval(parse(text = paste("region_zones$zones_count$", chr,
                                    "$n_zones", sep = "")))) !=
        length(eval(parse(text = paste("base_zones$zones_count$", chr,
                                    "$n_zones", sep = "")))))
        stop("The lengths of the three input dataframe are different,
            comparison not possible")

    ## dataframe with the number of zones for the three inputs
    n_zones <- data.frame(eval(parse(text = paste("TF_zones$zones_count$",
                        chr,"$n_zones", sep = ""))),
                        eval(parse(text = paste("region_zones$zones_count$",
                        chr,"$n_zones", sep = ""))),
                        eval(parse(text = paste("base_zones$zones_count$",
                        chr,"$n_zones", sep = ""))))
    ## scaled values of n_zones
    zone <- data.frame(scale(n_zones))
    names(zone)=c("TF_zones", "region_zones", "base_zones")
    ## PCA
    pca <- prcomp(zone)

    ## barplot with variances
    barplot(pca$sdev^2, main = "Variances of the principal components",
        ylab = "Variances", names.arg = c("Comp1", "Comp2", "Comp3"))
    ## plot with cumulate variances
    plot(cumsum(pca$sdev^2/sum(pca$sdev^2)), type = "l", main =
        "Cumulate variances of the principal components", ylab = "Contribute to
        total variance", xlab = "Number of components", xaxt = "n")
    axis(1, c(1, 2, 3))

    ## plots with loadings
    par(mfrow = c(3, 1))
    barplot(pca$rotation[, 1], ylim = c(-1, 1), names.arg = c("TF", "region",
        "base"), ylab = "Comp1")
    barplot(pca$rotation[, 2], ylim = c(-1, 1), names.arg = c("TF", "region",
        "base"), ylab = "Comp2")
    barplot(pca$rotation[, 3], ylim = c(-1, 1), names.arg = c("TF", "region",
        "base"), ylab = "Comp3")
    mtext("Loadings of the principal components", outer = TRUE)
    return(list(summary = summary(pca), loadings = pca$rotation))
    }

## The function plots the number of dense zones for each threshold value.
## Input:
##    zones: a list of eight elements, as the output of the dense_zones
##    function.
##    chr: optional argument, needed if the input is found with chr = "all";
##    a string or a vector containing strings with the name of the chromosome(s)
##    (e.g., "chr1" or c("chr1", "chr4"))
## Output: a plot(or more) with the number of dense zones found.

plot_n_zones <- function(zones, chr = NULL) {
    if (!is.list(zones))
        stop("'zones' must be an object of type 'list'.")
    if (zones$chr != "all") {
        chr <- zones$chr
        }
    for (i in seq_along(chr)) {
    plot(eval(parse(text = paste("zones$zones_count$", chr[i],"$threshold",
                                sep = ""))),
        eval(parse(text = paste("zones$zones_count$", chr[i],"$n_zones",
                                sep = ""))), type = "l",
        xlab = "threshold", ylab = "# zones", main =
        paste(chr[i],": number of dense DNA zones for different values \nof ",
        zones$acctype, " accumulation (threshold)", sep = ""))
    ## finding the point with max slope change.
    d <- diff(diff(eval(parse(text = paste("zones$zones_count$", chr[i],
                                        "$n_zones", sep = "")))))
    max_slope_change_position <- eval(parse(text = paste("zones$zones_count$",
                                chr[i],"$threshold", sep = "")))[1 +
                                which.max(abs(d))]
    points(max_slope_change_position, eval(parse(text =
                                                paste("zones$zones_count$",
                                                chr[i],"$n_zones",
                                                sep = "")))[which
        (eval(parse(text = paste("zones$zones_count$", chr[i],"$threshold",
                            sep = ""))) == max_slope_change_position)],
                            col = "red", lwd = 3)
    legend("topright", legend = c("max slope change"), col = "red", pch = 1)

    }
}

## The function is used to plot the number of dense zones and the number of
## bases belonging to these dense zones obtained (all with accumulation
## threshold=1) from different values of w.
## Input:
##    input_list: a list containing multiple outputs of the dense_zones
##    function, obtained for the same accumulation type, same chromosome and
##    different values of w.
##    chr: optional argument, needed if the input is found with chr = "all";
##    a string or a vector containing strings with the name of the chromosome(s)
##    (e.g., "chr1" or c("chr1", "chr4"))

w_analysis <- function(input_list, chr = NULL) {
    if (!is.list(input_list))
        stop("'input_list' must be an object of type 'list'.")

    chromosomes <- vector()
    acc_types <- vector()
    windows <- vector()
    for (i in 1:length(input_list)) {
        chromosomes[i] <- input_list[[i]]$chr
        windows[i] <- input_list[[i]]$w
        acc_types[i] <- input_list[[i]]$acctype
    }
    if (length(unique(windows)) != length(input_list))
        stop("The sizes of the windows are the same. The comparison it's not
            possible")


    ## Check that the input data acc_types are the same
    if (length(unique(acc_types)) != 1)
        stop("The accumulation types related to the input
            arguments are not the same. The comparison it's not possible")

    if (unique(chromosomes) != "all" & length(unique(chromosomes)) == 1) {
        chr <- unique(chromosomes)
    }


    for(k in seq_along(chr)) {

        n_bases <- vector()
        n_zones <- vector()

        for (i in 1:length(input_list)) {

        n_bases[i] <- eval(parse(text = paste("input_list[[i]]$bases_count$",
                                        chr[k],"$n_bases[1]", sep = "")))
        n_zones[i] <- eval(parse(text = paste("input_list[[i]]$zones_count$",
                                        chr[k],"$n_zones[1]", sep = "")))
    }

    ## Check that the input data windows are different




    ## plot(x axis logarithmic)
    plot(windows[order(windows)], n_bases[order(windows)], log = "x",
        type = "l", lty = 2, ylab = "# bases", col = "blue", xaxt = "n", yaxt =
        "n", xlab = "neighborhood half-width (log)", main = paste(chr[k],":
        Number of detected events (DNA zones or bases) \nvs. neighborhood window
        half-width",sep=""))
    axis(1, at = windows)
    axis(2, at = n_bases, col = "blue")
    par(new = TRUE)
    plot(windows[order(windows)], n_zones[order(windows)], log = "x",
        type = "l", ylab = "", xlab = "", col = "red", axes = FALSE)
    axis(4, at = n_zones, col = "red")
    mtext("# zones", side = 4)
    legend("left", legend = c("# bases", "# zones"), col = c("blue", "red"),
        lty = c(2,1), cex = 0.6)

    }
}

---
title: "TFHAZ"
subtitle: "Transcription Factor High Accumulation Zones"
author: 
    - Alberto Marchesi  <alberto.march91@gmail.com> 
    - Marco Masseroli
date: "`r doc_date()`"
package: "`r pkg_ver('TFHAZ')`"
output: 
    BiocStyle::html_document:
        toc_float: true
bibliography: references.bib
csl: american-medical-association-no-et-al.csl
vignette: >
    %\VignetteIndexEntry{TFHAZ}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}

---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

```{r, include=FALSE}
library(TFHAZ)
library(GenomicRanges)
library(IRanges)
library(S4Vectors)
data("data_man")
```

# Introduction

Transcription factors (TFs) are proteins that bind the DNA in specific regions 
and regulate gene expression. The regolation of the gene expression is often 
controlled by many TFs interacting with each other. Recent high throughput 
methods like chromatin immunoprecipitation followed by sequencing (ChIP-seq) 
[@park2009chip] provide a large number of data regarding TF binding regions, 
which are available in public repositories such as ENCODE [@encode2004encode] 
or Roadmap Epigenomics [@bernstein2010nih].   
Starting from a dataset containing the genomic positions of TF binding regions, 
the *TFHAZ* package allows finding trascription factor high accumulation DNA 
zones, i.e., regions along the genome where there is a high presence of 
different transcription factors. In addition, some functions are provided in 
order to analyze and compare results obtained with different input parameters.

# Dataset

Transcription factor dense DNA zones are found from a GRanges object that 
contains genomic regions of transcription factors at the ranges side and the 
name of the transcription factors at the metadata side. As in every object of 
GRanges class, the genomic coordinates are located on the left-hand side. The 
first column of the ranges side contains the chromosome of each region; the 
second column contains the genomic coordinates of each region (starting and 
ending position of the transcription factor binding region, considering a 
1-based inclusive coordinate system); the third column contains the strand of 
each region ("+", "-", or "\*" if unknown).   
The dataset we consider (called *Ishikawa*) is obtained from computation of 
ENCODE ChIP-Seq data of the localization of transcription factor binding regions
for the Ishikawa cell line. The data have been processed and extracted with GMQL
(GenoMetric Query Language http://www.bioinformatics.deib.polimi.it/GMQL/) 
[@masseroli2015genometric] [@ceri2016data] [@masseroli2016modeling]. 
The *Ishikawa* dataset contains 283,009 ranges of 16 different transcription 
factors.

```{r}
# load and visualize the dataset:
data("Ishikawa")
dim(as.data.frame(Ishikawa))
head(Ishikawa)

```

# Transcription factor accumulation
The first step in finding transcription factor dense DNA zones is to count the 
accumulation of TFs for each chromosome base. The function *accumulation* in the
*TFHAZ* package creates a vector in which, for each chromosome base, the 
accumulation of the TFs present in the input dataset is calculated. We 
considered three types of accumulation: TF accumulation, region accumulation 
and base accumulation.  

*TF accumulation*: for each base, it is the number of different TFs present in 
the neighborhood of the considered base. The neighborhood is defined by a window
with half-width w centered on the considered base.  

*Region accumulation*: for each base, it is the number of regions containing TFs
in the neighborhood of the considered base. If in the neighborhood of a base 
there are two input binding regions of the same TF, the accumulation value in 
that base is equal to 2 (differently from the TF accumulation, whose value in 
the same case is equal to 1).  

*Base accumulation*: for each base, it is the total number of bases belonging to
input regions containing TFs in the neighborhood of the considered base.  

With w = 0, a single base approach is applied (no base neighborhood is 
considered). In this case, if in the input dataset overlapping regions for the 
same TF and chromosome do not exist, the results of *TF*, *region* and *base* 
accumulation are equal.  

The function *accumulation* takes in input:   

* a GRanges object containing coordinates of TF binding regions and their TF 
name;
* a string with the name of the accumulation type: "TF", "region", "base"; 
* a string with the name of the chromosome (e.g., "chr1") With chr = "all", all 
the chromosomes in the input GRanges object are considered; 
* an integer, half-width of the window that defines the neighborhood of each 
base.     

The result of the *accumulation* function is a list containing: 

* accvector: a Rle (or SimpleRleList if chr = "all") object containing the
accumulation for each base of the selected chromosome;
* acctype: a string with the accumulation type used; 
* chr: a string with the chromosome name associated with the accumulation 
vector; 
* w: an integer with the half-width of the window used to calculate the 
accumulation vector.   

The accumulation vector obtained can be plotted using the function 
*plot_accumulation*.  
This function takes in input the output of the *accumulation* function and saves
the plot in a *.png* file. If the accumulation input is found with chr = "all", 
the chromosomes (one or more) to be considered can be chosen by the "chr" 
argument.


```{r}
# calculate TF accumulation for the chromosome 21 for w=0
TF_acc_21_w_0 <- accumulation(Ishikawa, "TF", "chr21", 0)
```

```{r, eval=FALSE}
# plot the accumulation vector
plot_accumulation(TF_acc_21_w_0)
```

```{r, echo=FALSE, fig.align='center', out.width='75%', fig.cap = "*Plot of the TF accumulation vector for the chromosome 21, obtained for w=0.*"}
knitr::include_graphics('./TF_w_0_chr21.png')
```



As we can see in Figure 1, in this example considering no base neighborhood 
(w=0), the maximum value of accumulation found is 14. It means that in the bases
with that accumulation value there are overlapping binding regions of 14 out of the 16 transcription factors present in the dataset.

# Transcription factor dense DNA zones

Once the accumulation for each chromosome base is calculated, we can find 
transcription factor dense zones with the *dense_zones* function. For each 
accumulation threshold value defined, the function finds transcription factor 
dense DNA zones (regions). Starting from the accumulation vector calculated with
the *accumulation* function, each dense zone is formed by contiguous bases with 
accumulation equal or higher than the threshold. Threshold values are selected 
by setting the *threshold_step* parameter.    
For each accumulation threshold value, a ".bed" file with the chromosome and 
genomic coordinates of the dense zones found can be created (Figure 2). The 
function finds also the number of dense zones, the number of total bases 
belonging to the dense zones, the minimum, maximum, mean, median and standard
deviation of the dense zone lengths and of the distances between adjacent dense
zones.   

The function *dense_zones* takes in input:  

- a list of four elements containing: a Rle (or SimpleRleList) with accumulation
values (e.g., obtained with the *accumulation* function), the accumulation type, 
a chromosome name, and the half-width of the window used for the accumulation 
count;
* an integer, the step used to calculate the threshold values. These values vary
from 1 to the maximum accumulation value in the considered accumulation
vector (e.g., found with the *accumulation* function);
* a string with a cromosome name (chr, optional argument). It is needed to apply
the function only to a single cromosome present in the accumulation input found.
If chr = "all" (default value) the function operates on all 
the chromosomes present in the input;
* a logical argument, writeBed. When set to TRUE, for each threshold value 
(and for each chromosome) a ".bed" file with the chromosome and genomic 
coordinates of the dense zones found is created.

The result of the *dense_zones* function is a list containing:  

* zones: a list with "GRanges" objects with the dense zones found for each 
chromosome and threshold value considered.
* zones_count: a list with a data frame for each chromosome considered,
containing the considered threshold values and the number of dense zones
obtained with each of the threshold values;
* bases_count:  a list with a data frame for each chromosome considered,
containing the considered threshold values and the total number of bases
belonging to the dense zones obtained with each of the threshold values;
* lengths: a list with a data frame for each chromosome considered,
containing the considered threshold values and min, max, mean, median and
standard deviation of the dense zone lengths obtained with each of the
considered threshold values;
* distances: a list with a data frame for each chromosome considered,
containing the considered threshold values and min, max, mean, median and 
standard deviation of the distances between adjacent dense zones obtained with
each of the threshold values;
* acctype: a string with the accumulation type used;
* chr: a string with the chromosome name associated with the output zones;
* w: an integer with half-width of the window used to calculate the accumulation
vector.

```{r}
# find dense DNA zones, with threshold step equal to 1
TF_dense_21_w_0 <- dense_zones(TF_acc_w_0, 1, chr = "chr21")
TF_dense_21_w_0
```



```{r, echo=FALSE, fig.align='center', fig.small = TRUE, fig.cap = "*Content of the 'bed' file with the coordinates of the seven dense DNA zones found  for the chromosome 21 with transcription factor accumulation threshold value equal to 12.*"}
knitr::include_graphics('./dense_zones_12.PNG')
```


We can plot the results present in the *zones_count* data frame with the 
function *plot_n_zones* (Figure 3) and we can see how the number of dense DNA 
zones decreases as the accumulation threshold value increases. The function also
plots the point of the graph with maximum slope change, corresponding to the 
maximum second derivative of the curve, circulating it with a red full line.

```{r, fig.align='center', fig.cap = "*Plot of the number of dense DNA zones found varying the TF accumulation threshold value for the chromosome 21; the point with maximum slope change is plotted circulated with a red full line.*"}
plot_n_zones(TF_dense_w_0, chr = "chr21")
```

\newpage
# Transcription factor dense DNA zones analysis

After finding transcription factor dense DNA zones, we can use two functions of 
the *TFHAZ* package to compare the results obtained with different values of *w*
half-width of the base neighborhood window and different accumulation types.  

With the function *w_analysis* we can plot the number of dense zones and the 
total number of bases belonging to these dense zones present in a set of inputs,
obtained (all with accumulation threshold=1) using the *dense_zones* function, 
for the same accumulation type, same chromosome, and different values of *w* 
half-width of the window defining the neighborhood of each base. The function 
takes in input a list of multiple outputs of the *dense_zones* function and 
returns a plot (with x axis logarithmic-scale).  

```{r, fig.align='center', fig.cap="*Plot of the number of dense DNA zones (red full line) and of the total number of bases belonging to dense DNA zones (blue dashed line) obtained with different values of neighborhood window half-width w for the chromosome 21.*"}
# l is a list with four objects obtained with the dense_zones function with 
# w = 10, 100, 1000, 10000.
l <- list(TF_dense_w_10, TF_dense_w_100, TF_dense_w_1000, TF_dense_w_10000)
# plot
w_analysis(l, chr = "chr21")
```  


If we consider the four different values of *w* half-width of the base 
neighborhood window in the example, we can notice in Figure 4 that the two 
measures (i.e., the number of dense zones and the total number of bases 
belonging to these dense zones) are inversely correlated; the number of bases 
increases with the size of the neighborhood, while the number of dense zones 
decreases. Furthermore, observing the plot, we can notice that the highest 
increase or decrease of the two measures occurs when the half-width of the 
neighborhood assumes values higher than 1000 bases. So, w=1000 can be considered
a good value in finding dense zones when using an accumulation approach with 
neighborhood (w different from 0). It is worth noting that the calculation time 
of the accumulation vector increases considerably with higher values of w.


In order to understand how to integrate the results obtained with the three 
different accumulation types, using the function *n_zones_PCA* we can perform 
the Principal Component Analysis (PCA) [@johnson2014applied] [@bro2014principal]
of the number of dense zones obtained by varying the threshold on accumulation 
values obtained with the three methods of accumulation (TF, region, base).  

The Principal Component Analysis produces a low dimensional representation of a 
dataset, finding a linear sequence of linear combinations of the variables that 
have maximal variance. 
With PCA we want to find if there is a possible way to combine the three 
measures (TF, region, base accumulation), or if the information obtained is the
same, and we can use only one of these measures for our study. For this purpose
it is useful to observe the variance associated with the first principal 
component and the loadings, the coefficients of the linear combination of each
principal component, that explain the proportion of each variable along each
principal component. 

This function takes in input:  

- a list with the results of the *dense_zones* function using the TF 
accumulation method and varying the thresholds on the considered accumulation
values;
- a list with the results of the *dense_zones* function using the region
accumulation method and varying the thresholds on the considered accumulation
values;
- a list with the results of the *dense_zones* function using the base
accumulation method and varying the thresholds on the considered accumulation
values.  
- an optional argument, chr, needed if the input was found with chr = "all";
a string or a vector containing strings with the name of the chromosome
(e.g., "chr1")

The outputs of the function are:  

* a list with a summary containing the standard deviation on each principal
component, the proportion of variance explained by each principal component, the
cumulative proportion of variance described by each principal component, and the
loadings of each principal component;
* a plot with the variances of the principal components;
* a plot with the cumulate variances of the principal components;
* a plot with the loadings of the three principal components.


Note that the function *n_zones_PCA* works only if the number of different
threshold
values used to find the dense zones with the *dense_zones* function is the same
for all the three accumulation types, while the threshold values can be
different. 


```{r PCA, fig.keep="none"}
# TF_dense_21_w_10 is the output of dense_zones function applied to the
# accumulation vector found with w=10, chr="chr21", acctype="TF".
# reg_dense_21_w_10 is the output of dense_zones function applied to the
# accumulation vector found with w=10, chr="chr21", acctype="reg".   
# base_dense_21_w_10 is the output of dense_zones function (with 
# threshold_step=21 in order to have 14 threshold values as in the other two
# inputs) applied to the accumulation vector found with w=10, chr="chr21",
# acctype="base".
# PCA
n_zones_PCA(TF_dense_w_10, reg_dense_w_10, base_dense_w_10, chr = "chr21")
```

```{r echo=FALSE, fig.align='center', out.width = '75%',fig.cap = "*Plot of the variances of the principal components.*"}
knitr::include_graphics('./PCA_1.png')
``` 

```{r echo=FALSE, fig.align='center', out.width='75%', fig.cap = "*Plot of the cumulate variances of the principal components.*"}
knitr::include_graphics('./PCA_2.png')
``` 
```{r echo=FALSE, fig.align='center', out.width='100%', fig.cap = "*Plot of the loadings of the three principle components.*"}
knitr::include_graphics('./PCA_3.png')
``` 


From this example we can see how the first principal component explains most of 
the variation (Figure 5 and Figure 6), so it accounts for maximum information.
Furthermore, we can see how the values of loadings of the first principal 
component are very similar (Figure 7). Therefore, we can say that the 
information obtained with the three methods of accumulation is the same and for 
our study regarding transcription factor dense DNA zones we can use only one 
method of the three; we suggest using the *TF* or *region accumulation* because 
the running time of the *accumulation* function with *acctype*=*base* is higher,
especially in chromosomes with an elevated number of input regions. 

# Transcription factor high accumulation DNA zones

In the previous part we found transcription factor dense DNA zones with
different thresholds of transcription factor accumulation, and we compared the
results using different input parameters in order to identify the best way to
find regions of the genome where there is a high presence of different
trascription factors. Now, with the function *high_accumulation_zones*, setting
only one threshold value, we can find these regions; we call them transcription
factor high accumulation DNA zones (TFHAZ). Starting from the accumulation
vector calculated with the *accumulation* function, two different methods 
for the search of TF high accumulation DNA zones are available. The *binding 
regions* method is based on the identification of DNA regions with presence of 
TF binding (at least one TF) from which those with a high number of different 
TFs (above the threshold) are selected. This method works only if the 
accumulation vector is found with *w=0*. The *overlaps* method is the method 
used also in *dense_zones* function. It uses a single base local approach, 
identifying DNA bases, that form the dense zones, in which there is high overlap
of TFs. For the *binding regions* method the high accumulation zones are the
accumulation regions with values higher or equal to the threshold, while in the
*overlaps* these zones are defined as sets of contiguous bases with accumulation
value higher or equal to the considered threshold. The threshold value is found
considering two methods. The *std* method considers all and only the bases of 
the accumulation vector (*accvector*) with values higher than zero, and the 
threshold is found with the following formula: *TH = mean(accvector) + 2 std(accvector)*. 
The *top_perc* method considers the accumulation regions and selects those in 
the top *x* percentage, with *x* chosen by the user through the *perc* argument. 
The function finds also the number of high accumulation zones, the number of 
total bases belonging  to these zones, the minimum, maximum, mean, median and standard 
deviation of these zone lengths and of the distances between adjacent high
accumulation zones. In the case of *binding regions* method, it is needed to 
include the *data* input argument, that is the GRanges object used in the
*accumulation* function.
Furhermore, in the case of single chromosome accumulation vector, the function 
can plot, for
each chromosome base (x axis), the value of accumulation (y axis) calculated
with the *accumulation* function. On this graph there are also shown the
threshold (with a red line) and, on the x axis, the bases belonging to the high
accumulation zones (with red boxes). The plot can be saved in a ".png" file.
The function also can generate a ".bed" file with the chromosome and genomic
coordinates of the high accumulation zones found.



The function *high_accumulation_zones* takes in input:  

* a list of four elements containing: a sparse vector with accumulation values
(e.g., obtained with the \emph{accumulation} function), the accumulation type, a
chromosome name, and the half-width of the window used for the accumulation
count;
* a string with the name of the method used to find high accumulation zones:
"binding_regions" or "overlaps";
* a GRanges object containing coordinates of TF binding regions and their TF name.
It is needed in the case of *binding regions* method;
* a string with the name of the method used to find the threshold value:
"std" or "top_perc";
* an integer k (by defeault equals to 2) with the percentage (with the 
*top_perc* method) or the number of std deviations (with the *std* method) to 
be used in order to find the threshold.
* a logical argument, writeBed. When set to TRUE, for each threshold value a 
".bed" file with the chromosome and genomic coordinates of the dense zones found
is created.
* a logical argument, plotZones. When set to TRUE, and the *accumulation* in 
input is calculated for a single chromosome, a ".png" file with the plot of the 
high accumulation zones on the accumulation vector is created.

The result of the *high_accumulation_zones* function is a list containing:  

* zones: a GRanges object containing the coordinates of the high
accumulation zones.
* n_zones: an integer containing the number of high accumulation zones obtained;
* n_bases: an integer containing the total number of bases belonging to the high
accumulation zones obtained;
* lengths: a vector containing the considered threshold value and min, max,
mean, median and standard deviation of the high accumulation zone lengths
obtained;
* distances: a vector containing the considered threshold value and  min, max,
mean, median and standard deviation of the distances between adjacent high
accumulation zones obtained;
* TH: a number with the threshold value found;
* acctype: a string with the accumulation type used;
* chr: a string with the chromosome name associated with the accumulation vector
used;
* w: an integer with half-width of the window used to calculate the accumulation
vector.


```{r}
# find high accumulation DNA zones
TF_acc_21_w_0 <- accumulation(Ishikawa, "TF", "chr21", 0)
TFHAZ_21_w_0 <- high_accumulation_zones(TF_acc_21_w_0, method = "overlaps",
threshold = "std")
TFHAZ_21_w_0
```

From the results of this example we can see that for the *overlaps* method with 
a threshold equal to 7.3 (obtained with the *std* method) we find 93 high
accumulation zones. We can see the distribution of these zones along the 
chromosome (in this case the chromosome 21) in Figure 8, while in
Figure 9 it is shown a part (31 out of 93 zones) of the ".bed" file with the
coordinates of the zones.

```{r echo=FALSE, fig.align="center", out.width='75%',fig.cap = "*Plot of the TF accumulation vector (for the chromosome 21, obtained for w=0) and of the high accumulation DNA zones (red boxes on the x axis) found; the threshold used to find these zones (7,268413) is shown with a red horizontal line.*"}
knitr::include_graphics('./high_accumulation_zones_TH_7.3_TF_acc_w_0_chr21.png')
```

```{r echo=FALSE, fig.align='center', fig.small = TRUE, fig.cap = "*Content of the 'bed' file with the coordinates of 31 out of the 93 high accumulation DNA zones found.*"}
knitr::include_graphics('./HAZ_bed.PNG')
```


# Acknowledgement

We really appreciate the generous support and suggestions by Stefano Campaner
and Stefano Perna. 

# References

\name{TF_acc_w_0}
\alias{TF_acc_w_0}
\docType{data}
\title{
Contains an output of the accumulation function.
}
\description{
\emph{TF_acc_w_0} is a list of 4 elements (\emph{acc_vector},
\emph{acc_type}, \emph{chr}, \emph{w}). It is the output of the accumulation
function with acctype="TF", chr="all", w=0. \emph{TF_acc_w_0} is included
in the \emph{data_man} collection.
}
\usage{data("data_man")}
\value{
None, the function is invoked for its side effect.
}
\format{
An object of class list.
}
\examples{
# loading data
data("data_man")
# TF_acc_w_0 is in the data_man collection of datasets
head(TF_acc_w_0)
}
\keyword{datasets}

\name{plot_accumulation}
\alias{plot_accumulation}

\title{
Plots the accumulation vector obtained with the accumulation function.
}
\description{
For each chromosome base (x axis), this function plots the value of accumulation
(y axis) calculated with the \emph{accumulation} function. The plot is saved in
a ".png" file. If the accumulation input was found with chr = "all", the
chromosomes (one or more) to be considered can be chosen.
}
\usage{
plot_accumulation(accumulation, chr = NULL)
}

\arguments{
\item{accumulation}{
a list of four elements, as the output of the \emph{accumulation} function,
containing: a sparse vector with accumulation values, the accumulation type, a
chromosome name, and the half-width of the window used for the accumulation
count.
}
\item{chr}{
optional argument, needed if the accumulation input was found with chr = "all";
a string or a vector containing strings with the name of the chromosome(s)
(e.g., "chr1" or c("chr1", "chr4")) to be considered.
}
}

\value{
None, the function is invoked for its side effect.
}

\examples{
\donttest{
# loading dataset
data("data_man")
# TF_acc_w_0 is in the data_man collection of datasets
# plot accumulation vector
plot_accumulation(TF_acc_w_0)}
}

\name{high_accumulation_zones}
\alias{high_accumulation_zones}

\title{Finds transcription factor high accumulation DNA zones.
}
\description{
This function finds transcription factor high accumulation DNA zones (TFHAZ).
Starting from the accumulation vector calculated with the \emph{accumulation}
function, two different methods for the search of TF high accumulation DNA zones
are available. The \emph{binding regions} method is based on the identification
of DNA regions with presence of TF binding (at least one TF) from which those
with a high number of different TFs (above the threshold) are selected. This
method works only if the accumulation vector is found with \emph{w}=0. The
\emph{overlaps} method is the method used also in \emph{dense_zones} function.
It uses a single base local approach, identifying DNA bases, that form the dense
zones, in which there is high overlap of TFs. For the \emph{binding regions}
method the high accumulation zones are the accumulation regions with values
higher or equal to the threshold, while in the \emph{overlaps} these zones are
defined as sets of contiguous bases with accumulation value higher or equal to
the considered threshold. The threshold value is found considering two methods.
The \emph{std} method considers all and only the bases of the accumulation
vector (\emph{accvector}) with values higher than zero, and the threshold is
found with the following formula:
\emph{TH = mean(accvector) + k*std(accvector)}. The \emph{top_perc} method
considers the accumulation regions and selects those in the top k percentage.
In both the cases, the k is chosen by the user through the 
\emph{k} argument. The function finds also the number of high
accumulation zones, the number of total bases belonging to these zones, the
minimum, maximum, mean, median and standard deviation of these zone
lengths and of the distances between adjacent high accumulation zones. In the
case of \emph{binding regions} method, it is needed to include the \emph{data}
input argument, that is the GRanges object used in the \emph{accumulation}
function.
Furhermore, in the case of single chromosome accumulation vector, the function
can plots, for
each chromosome base (x axis), the value of accumulation (y axis) calculated
with the \emph{accumulation} function. On this graph there are also shown the
threshold (with a red line) and, on the x axis, the bases belonging to the high
accumulation zones (with red boxes). The plot can be saved in a ".png" file.
}
\usage{
high_accumulation_zones(accumulation, method = c("overlaps", "binding_regions"),
data, threshold = c("std","top_perc"), k, writeBed = FALSE, plotZones =
FALSE)
}

\arguments{
\item{accumulation}{
a list of four elements containing: a Rle object (or SimpleRleList) with
accumulation values
(e.g., obtained with the \emph{accumulation} function), the accumulation type,
a chromosome name, and the half-width of the window used for the accumulation
count.
}
\item{method}{
a string with the name of the method used to find high accumulation zones:
"binding_regions" or "overlaps".
}
\item{data}{
a GRanges object containing coordinates of TF binding regions and their TF name.
It is needed in the case of \emph{binding regions} method.
}
\item{threshold}{
a string with the name of the method used to find the threshold value:
"std" or "top_perc".
}
\item{k}{
an integer with the percentage (with the \emph{top_perc} method) or the number 
of std deviations (with the \emph{std} method) to be used in order to find 
the threshold.
}
\item{writeBed}{
When set to TRUE, for each threshold value a ".bed"
file with the chromosome, genomic coordinates and accumulation values of the 
found dense zones is created.
}
\item{plotZones}{
When set to TRUE, and the "accumulation" in input is calculated for a single
chromosome, a ".png" file with the plot of the high accumulation zones on the
accumulation vector is created.
}
}

\value{
A list of nine elements:
\item{zones}{a GRanges object containing the coordinates of the high
accumulation zones.}
\item{n_zones}{an integer containing the number of high accumulation zones
obtained.}
\item{n_bases}{an integer containing the total number of bases belonging to the
high accumulation zones obtained.}
\item{lengths}{a vector containing the considered threshold value and min, max,
mean, median and standard deviation of the high accumulation zone lengths
obtained.}
\item{distances}{a vector containing the considered threshold value and  min,
max, mean, median and standard deviation of the distances between adjacent high
accumulation zones obtained.}
\item{TH}{a number with the threshold value found.}
\item{acctype}{a string with the accumulation type used.}
\item{chr}{a string with the chromosome name associated with the accumulation
vector used.}
\item{w}{an integer with half-width of the window used to calculate the
accumulation vector.}

}

\examples{
# loading dataset
data("Ishikawa")
# TF_acc_w_0 is in the data_man collection of datasets
# to find high accumulation zones
TFHAZ_w_0 <- high_accumulation_zones(TF_acc_w_0, method = "overlaps",
threshold = "std")

}

\name{n_zones_PCA}
\alias{n_zones_PCA}

\title{
Principal Component Analysis of the number of dense zones obtained with the
three methods of accumulation (TF, region, base).
}
\description{
This function performs the Principal Component Analysis (PCA) of the number of
dense zones obtained by varying the threshold on accumulation values obtained
with the three methods of accumulation (\emph{TF}, \emph{region}, \emph{base}).
Before performing the PCA, the number of dense zone values are scaled with the
\emph{scale} R function. This function works only if the number of different
threshold values used to find the dense zones with the \emph{dense_zones}
function is the same for all the three accumulation types, while the threshold
values can be different.
}
\usage{
n_zones_PCA(TF_zones, region_zones, base_zones, chr = NULL)
}

\arguments{
\item{TF_zones}{
a list with the results of the \emph{dense_zones} function using the TF
accumulation method and varying the thresholds on the considered accumulation
values.
}
\item{region_zones}{
a list with the results of the \emph{dense_zones} function using the region
accumulation method and varying the thresholds on the considered accumulation
values.
}
\item{base_zones}{
a list with the results of the \emph{dense_zones} function using the base
accumulation method and varying the thresholds on the considered accumulation
values.
}
\item{chr}{
optional argument, needed if the input was found with chr = "all";
a string or a vector containing strings with the name of the chromosome
(e.g., "chr1")
}
}
\value{
A list with a summary containing the standard deviation on each principal
component, the proportion of variance explained by each principal component,
the cumulative proportion of variance described by each principal component,
and the loadings of each principal component. In addition, a plot with the
variances of the principal components; a plot with the cumulate variances of the
principal components and a plot with the loadings of the three principal
components.


}

\examples{
# loading data
data("data_man")
# TF_dense_w_10, reg_dense_w_10, and base_dense_w_10 are in the
#data_man collection of datasets
# PCA
n_zones_PCA(TF_dense_w_10, reg_dense_w_10, base_dense_w_10)
}

\name{base_dense_w_10}
\alias{base_dense_w_10}
\docType{data}
\title{
Contains an output of the dense_zones function.
}
\description{
\emph{base_dense_w_10} is a list of 8 elements (\emph{zones},
\emph{zones_count}, \emph{bases_count}, \emph{lengths}, \emph{distances},
\emph{acctype}, \emph{chr}, \emph{w}). It is the output of \emph{dense_zones}
function (with \emph{threshold_step=21} in order to have 14 threshold values)
applied to the accumulation vector found with w=10, chr="all", acctype="base".
\emph{base_dense_w_10} is included in the \emph{data_man} collection.
}
\usage{data("data_man")}
\value{
None, the function is invoked for its side effect.
}
\format{
An object of class list.
}
\examples{
# loading data
data("data_man")
# base_dense_w_10 is in the data_man collection of datasets
head(base_dense_w_10)
}
\keyword{datasets}

\name{accumulation}
\alias{accumulation}
\title{
Creates a vector with accumulation counts of transcription factors for each
chromosome base.
}
\description{
From a dataset with transcription factor (TF) binding regions, this function
creates a vector (\emph{accvector}) in which, for each chromosome base, the
accumulation of the TFs present in the input dataset is calculated.
Three types of accumulation are considered: \emph{TF accumulation}, \emph{region
accumulation} and \emph{base accumulation}.
TF accumulation: for each base, it is the number of different TFs present in the
neighborhood of the considered base. The neighborhood is defined by a window
with half-width \emph{w} centered on the considered base.
Region accumulation: for each base, it is the number of regions containing TFs
in the neighborhood of the considered base. If in the neighborhood of a base
there are two input binding regions of the same TF, the accumulation value in
that base is equal to 2 (differently from the TF accumulation, whose value in
the same case is equal to 1).
Base accumulation: for each base, it is the total number of bases belonging to
input regions containing TFs in the neighborhood of the considered base.
With w=0, a single base approach is applied (no base neighborhood is
considered). In this case, if in the input dataset overlapping regions for the
same TF and chromosome do not exist, the results of TF, region and base
accumulation are equal.



}
\usage{
accumulation(data, acctype, chr, w)
}

\arguments{
\item{data}{
a GRanges object containing coordinates of TF binding regions and their TF name.
}
\item{acctype}{
a string with the name of the accumulation type: "TF", "region", "base".
}
\item{chr}{
a string with the name of the chromosome (e.g., "chr1"). With chr = "all" all
the chromosomes in the input GRanges object are considered.
}
\item{w}{
an integer, half-width of the window that defines the neighborhood of each base.
}
}

\value{
A list of four elements:
\item{accvector}{a Rle (or SimpleRleList if chr = "all") object containing the
accumulation for each base of the selected chromosome.}
\item{acctype}{a string with the accumulation type used.}
\item{chr}{a string with the chromosome name associated with the accumulation
vector.}
\item{w}{an integer with the half-width of the window used to calculate the
accumulation vector.}
}
\examples{

# loading dataset
data("Ishikawa")
# to calculate TF accumulation for the chromosome 21 for w=0
TF_acc_21_w_0 <- accumulation(Ishikawa,"TF","chr21",0)

}

\name{dense_zones}
\alias{dense_zones}

\title{
Finds transcription factor dense DNA zones for different accumulation threshold
values.
}
\description{
For each accumulation threshold value defined, this function finds transcription
factor (TF) dense DNA zones (regions). Starting from the accumulation vector
calculated with the \emph{accumulation} function, each dense zone is formed by
contiguous bases with accumulation equal or higher than the threshold.
For each defined threshold value, the function finds also the number of dense
zones, the number of total bases belonging to the dense zones, the minimum,
maximum, mean, median and standard deviation of the dense zone lengths and of
the distances between adjacent dense zones.
}
\usage{
dense_zones(accumulation, threshold_step, chr = NULL, writeBed = FALSE)
}

\arguments{
\item{accumulation}{
a list of four elements containing: a Rle (or SimpleRleList) object with
accumulation values
(e.g., obtained with the \emph{accumulation} function), the accumulation type,
a chromosome name, and the half-width of the window used for the accumulation
count.
}
\item{threshold_step}{
an integer, the step used to calculate the threshold values. These values vary
from 1 to the maximum accumulation value in the considered accumulation vector
(e.g., found with the \emph{accumulation} function). In the case of using
accumulation values of base accumulation type and w different from zero (e.g.,
w=1000), choosing a step quite different from 1 is suggested because the maximum
accumulation value is usually high.
}
\item{chr}{
optional argument, a string with a cromosome name. It is needed to apply the
function only to a single cromosome present in the accumulation input. If
chr = "all" (default value) the function operates on all the
chromosomes present in the input.
}
\item{writeBed}{
When set to TRUE, for each threshold value (and for each chromosome) a ".bed"
file with the chromosome and genomic coordinates of the dense zones found is
created.
}
}
\value{
A list of eight elements:
\item{zones}{a list with "GRanges" objects with the dense zones found for each
chromosome and threshold value considered.
}
\item{zones_count}{a list with a data frame for each chromosome considered,
containing the considered threshold values and the number of dense zones
obtained with each of the threshold values.}
\item{bases_count}{a list with a data frame for each chromosome considered,
containing the considered threshold values and the total number of bases
belonging to the dense zones obtained with each of the threshold values.}
\item{lengths}{a list with a data frame for each chromosome considered,
containing the considered threshold values and min, max, mean, median and
standard deviation of the dense zone lengths obtained with each of the
considered threshold values.}
\item{distances}{a list with a data frame for each chromosome considered,
containing the considered threshold values and min, max, mean, median and
standard deviation of the distances between adjacent dense zones obtained with
each of the threshold values.}
\item{acctype}{a string with the accumulation type used.}
\item{chr}{a string with the chromosome name associated with the output zones.}
\item{w}{an integer with half-width of the window used to calculate the
accumulation vector.}

When writeBed is set to TRUE, for each threshold value (and for each chromosome)
a ".bed" file with the chromosome and genomic coordinates of the dense zones
found is created.

}

\examples{
# loading data
data("data_man")
# TF_acc_w_0 is in the data_man collection of datasets
# to find dense zones, with threshold step equal to 1
TF_dense_w_0 <- dense_zones(TF_acc_w_0, 1)
}

\name{TF_dense_w_1000}
\alias{TF_dense_w_1000}
\docType{data}
\title{
Contains an output of the dense_zones function.
}
\description{
\emph{TF_dense_w_1000} is a list of 8 elements (\emph{zones},
\emph{zones_count}, \emph{bases_count}, \emph{lengths}, \emph{distances},
\emph{acctype}, \emph{chr}, \emph{w}). It is the output of the
\emph{dense_zones} function applied to the accumulation vector found with
w=1000, chr="all", acctype="TF". \emph{TF_dense_w_1000} is included in the
\emph{data_man} collection.
}
\usage{data("data_man")}
\value{
None, the function is invoked for its side effect.
}
\format{
An object of class list.
}
\examples{
# loading data
data("data_man")
# TF_dense_w_1000 is in the data_man collection of datasets
head(TF_dense_w_1000)
}
\keyword{datasets}

\name{Ishikawa}
\alias{Ishikawa}
\docType{data}
\title{
Contains genomic regions of transcription factors at the ranges side
and the name of the transcription factors at the metadata side.
}
\description{
\emph{Ishikawa} is a Large GRanges object with 283,009 ranges and 1 metadata
column. Each range represents the coordinates of a TF binding region while
metadata column indicates the name of the TF.
}
\usage{data("Ishikawa")}
\value{
None, the function is invoked for its side effect.
}
\format{
An object of class "GRanges"
}
\details{
The dataset is obtained from computation of ENCODE ChIP-Seq data of the
localization of transcription factor binding sites of the Ishikawa cell line.
The data have been processed and extracted with GMQL (GenoMetric Query Language
http://www.bioinformatics.deib.polimi.it/ GMQL/).
}
\examples{
# loading dataset
data("Ishikawa")
head(Ishikawa)
}
\keyword{datasets}

\name{plot_n_zones}
\alias{plot_n_zones}

\title{
Plots the number of dense zones for each threshold value.
}
\description{
For each accumulation threshold value considered, this function shows the number
of dense zones found (e.g., with the \emph{dense_zones} function). It also plots
in red color the point of the graph with maximum slope change (maximum second
derivative).
}
\usage{
plot_n_zones(zones, chr = NULL)
}

\arguments{
\item{zones}{
a list of eight elements, as the output of the \emph{dense_zones} function.
}
\item{chr}{
optional argument, needed if the input was found with chr = "all";
a string or a vector containing strings with the name of the chromosome(s)
(e.g., "chr1" or c("chr1", "chr4")) to be considered
}
}

\value{
None, the function is invoked for its side effect.
}

\examples{
# loading data
data("data_man")
# TF_dense_w_0 is in the data_man collection of datasets
# plot number of zones
plot_n_zones(TF_dense_w_0)
}

\name{reg_dense_w_10}
\alias{reg_dense_w_10}
\docType{data}
\title{
Contains an output of the dense_zones function.
}
\description{
\emph{reg_dense_w_10} is a list of 8 elements (\emph{zones}, \emph{zones_count},
\emph{bases_count}, \emph{lengths}, \emph{distances}, \emph{acctype},
\emph{chr}, \emph{w}). It is the output of the \emph{dense_zones} function
applied to the accumulation vector found with
w=10, chr="all", acctype="reg". \emph{reg_dense_w_10} is included in the
\emph{data_man} collection.
}
\usage{data("data_man")}
\value{
None, the function is invoked for its side effect.
}
\format{
An object of class list.
}
\examples{
# loading data
data("data_man")
# reg_dense_w_10 is in the data_man collection of datasets
head(reg_dense_w_10)
}
\keyword{datasets}

\name{w_analysis}
\alias{w_analysis}

\title{
Shows the number of dense zones obtained with different values of base
neighborhood window width.
}
\description{
This function is used to plot the number of dense zones and the total number of
bases belonging to these dense zones present in a set of inputs, obtained (all
with accumulation threshold=1) using the \emph{dense_zones} function, for the
same accumulation type, same chromosome, and different values of \emph{w}
half-width of the window defining the neighborhood of each base. The plot (with
x axis logarithmic-scale) is generated only if all input data refer to the same
accumulation type, otherwise an error message appears. Beside
helping in comparing results obtained with different values of \emph{w}, this
function supports finding the best value of \emph{w} to be used in further
analysis.
}
\usage{
w_analysis(input_list, chr = NULL)
}

\arguments{
\item{input_list}{
a list containing multiple outputs of the \emph{dense_zones} function, obtained
for the same accumulation type, same chromosome and different values of
\emph{w}.
}
\item{chr}{
optional argument, needed if the input was found with chr = "all";
a string or a vector containing strings with the name of the chromosome(s)
(e.g., "chr1" or c("chr1", "chr4")) to be considered
}

}
\value{
None, the function is invoked for its side effect.
}
\examples{
# loading data
data("data_man")
# l is a list with dense zone (e.g., TF_dense_w_10, TF_dense_w_100,
# TF_dense_w_1000 and TF_dense_w_10000) objects present in data_man
# collection of datasets
l <- list(TF_dense_w_10, TF_dense_w_100, TF_dense_w_1000,
TF_dense_w_10000)
# plot
w_analysis(l)
}
